# Start the programm ####
cat("\n")
cat("####\n")
cat("Hallo Benutzer*in: Du hast das Script für den Tokenaufbereiter gestartet.\n") # nolint: line_length_linter.
cat("Nachfolgend werden jetzt:\n")
cat("- Alle notwendigen Pakete geladen.\n")
cat("- Alle erforderlichen Teilnehmerdaten aus den nachfolgenden Umfragen heruntergeladen.\n") # nolint
cat("+ 433442\n")
cat("+ 144481\n")
cat("+ 538473\n")
cat("-> Dauert ca. 10-20 Sekunden.\n")
cat("####\n")
cat("\n")

# preparatory work ####
# reset workspace #
rm(list = ls())

# setwd #
setwd("P:/IMEBI/DigiHero_Teilnehmerdaten/Massenmails/tokenaufbereiter")

cat("####\n")
cat("At the end, all generated files are stored in the following working directory:\n") # nolint: line_length_linter.
cat(getwd(),"/erstellte_Dateien","\n")
cat("####\n")

# load packages and source files #
suppressWarnings({
suppressMessages({

library(readxl)
library(writexl)
library(tidyverse)
library(lubridate)
  
source("./function_load.R")
source("./download_get_key.R")

})
})

# DOWNLOAD files #

#Umfragen ID:
# 433442
# |> diese Umfrage staret bei ID 43 und endet bei: 92813 (Stand: März 2024)
# |> Funktion: get_last_id habe nicht gefunden. Wert muss daher im Skript manuell angepasst werden.
# 144481
# 538473


#Vorlage für Download von den Antworten der Teilnehmer###
#ls_433442_0 <- get_responses(iSurveyID= 433442, sLanguageCode= 'de', sResponseType='short',
#                             iFromResponseID =1,
#                             iToResponseID=50)

#Download der Daten der Umfrageteilnehmer selbst###
#Schleife geht nicht -> keine Ahung warum
# for(i in 1:2){
#   paste0(lp,i)<- get_participants(iSurveyID = 433442,iStart=as.Integer(paste0(i,0001)),iLimit =as.Integer(paste0(i+1,0000)), bUnused=FALSE, aAttributes=FALSE)
#   #lp1<- get_participants(iSurveyID = 433442,iStart=20001,iLimit = 20000, bUnused=FALSE, aAttributes=FALSE)
# }
#wenn iLimit > 50.000 gibt es eine Fehlermeldung

#problem: token, firstname, etc. gets automatic downloaded
# you have to added the extra columns that needed
atr <- c(
  "emailstatus",
  "language"
  )
# nach Mareikes Skript wird nur die Spalte "language" und "emailstatus" benötigt
# -> emailstatus beinhaltet die Information "INVALID", damit Limesurvey keine Mails an diese Adressen sendet.
#atr <- c(
#  "emailstatus", "language","validfrom","validuntil","remindercount","completed","invited","reminded","usesleft")
# Die folgenden Spalten werden nicht geladen -> keine Ahnung warum. Sie werden auch nicht geladen, wenn man nur diese eingibt.
# Es gibt aber anscheinend keine implizite Mengenbeschränkung.
#"invited",
#"reminded",

# URSPRÜNGLICH VERWENDET::
# p_433442_00<- get_participants(iSurveyID = 433442,iStart=1,iLimit = 50000, bUnused=FALSE, aAttributes=atr)
# p_433442_01<- get_participants(iSurveyID = 433442,iStart=50001,iLimit = 100000, bUnused=FALSE, aAttributes=atr)
# Das ist aber falsch, da hier zuviele Daten geladen werden. Das iLimit gibt nicht an, bis wohin geladen wird, sondern wieviele Daten gezogen werden.

# Schleife -> nicht geschrieben
# Fehlerhafte Werte werden in nachfolgenden Prüfung wieder heraus sortiert
p_433442_00<- get_participants(iSurveyID = 433442,iStart=1,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_01<- get_participants(iSurveyID = 433442,iStart=25001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_02<- get_participants(iSurveyID = 433442,iStart=50001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_03<- get_participants(iSurveyID = 433442,iStart=75001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_04<- get_participants(iSurveyID = 433442,iStart=100001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_05<- get_participants(iSurveyID = 433442,iStart=125001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_06<- get_participants(iSurveyID = 433442,iStart=150001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_07<- get_participants(iSurveyID = 433442,iStart=175001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_08<- get_participants(iSurveyID = 433442,iStart=200001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_09<- get_participants(iSurveyID = 433442,iStart=225001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_10<- get_participants(iSurveyID = 433442,iStart=250001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_11<- get_participants(iSurveyID = 433442,iStart=275001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_12<- get_participants(iSurveyID = 433442,iStart=300001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_13<- get_participants(iSurveyID = 433442,iStart=325001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_14<- get_participants(iSurveyID = 433442,iStart=375001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)
p_433442_15<- get_participants(iSurveyID = 433442,iStart=400001,iLimit = 25000, bUnused=FALSE, aAttributes=atr)

# Liste für die Prüfung und Löschung
alle_p_433442 <- mget(ls(pattern = "^p_433442_"))
for (element in names(alle_p_433442)) {
  # Spalte "status" -> dann ist die Liste leer -> löschen
  if ("status" %in% colnames(alle_p_433442[[element]])) {
    rm(list = element, envir = .GlobalEnv)
  }
}
#Zwischenliste wieder entfernen
rm(alle_p_433442)

print("p_433442_xx vollständig heruntergeladen")

p_144481_00 <- get_participants(iSurveyID = 144481,iStart=1,iLimit = 50000, bUnused=FALSE, aAttributes=atr)
print("p_144481_00 heruntergeladen")
p_538473_00<- get_participants(iSurveyID = 538473,iStart=1,iLimit = 50000, bUnused=FALSE, aAttributes=atr)
print("p_538473_00 heruntergeladen")
#erste Idee für die Weiterarbeit ####
#binden und "tid" entfernen
#token144481 <- read.csv("tokens_144481.csv")
#token433442 <- read.csv("tokens_433442.csv")
#token538473 <- read.csv("tokens_538473.csv")
#token <- bind_rows(token144481,token433442,token538473)
#token <- token |> select (-c(tid)) |> distinct()

#alle "Test"-Zeilen entfernen
#TestTokens NUR über firstname identifizieren
#token<- token |> filter(!str_detect(tolower(firstname), 'test'))
cat("\n")
cat("####\n")
cat("Der Download wurde abgeschlossen.\n")
cat("Nun werden die heruntergeladen Tabellen verbunden.\n")
cat("####\n")

# start data cleaning ####

# Verbinden was ein data.frame ist.
# in diesem Code gibt es eh nur data.frame
filtered_data_frames <- Filter(function(x) is.data.frame(get(x)), ls())

# die "values" zu "Data" machen und die participant_info entschachteln
data_frames_list <- lapply(filtered_data_frames, get)
suppressWarnings({
  
data_frames_list2 <- lapply(data_frames_list, unnest)
})
# zusammenhängendes data.frame erzeugen, tid entfernen und doppelte werte löschen
combined_df <- do.call(rbind, data_frames_list2)
combined_df$tid <- NULL
unique_df <- combined_df[!duplicated(combined_df), ]

#löschen der Testdaten
values_to_delete = c("Test1","Test2","Test3","Test4","Test5","Test6","Test7","Test8","Test9",
                     "Test10","Test11","Test12","test","Test","Test Bestätigungsmail","Mareike Test",
                     "Test Mareike","Bianca TEST","AlexandraTest")

removed_test_values <- unique_df[!unique_df$firstname %in% values_to_delete, ]

#SAS und Anführungszeichen -> entfällt hier in R #

# Umlaute ersetzen #
# encode
cleaned_df <- removed_test_values |> mutate(across(firstname | lastname, 
                                \(x) stringr::str_replace_all(string = x, 
                                                              c('ä' = 'ae',
                                                                'ë' = 'ee',
                                                                'ï' = 'ie',
                                                                'ü' = 'ue', 
                                                                'ö' = 'oe',
                                                                'ß' = 'ss',
                                                                'ö' = 'oe',
                                                                '`' = '',
                                                                '´' = '',
                                                                'š' = 's',
                                                                'Ž' = 'z',
                                                                '–' = '-',
                                                                'õ' = 'oe',
                                                                'ẞ' = 'ss',
                                                                'ć' = 'c',
                                                                'â' = 'a',
                                                                'ż' = 'z',
                                                                'ä' = 'ae',
                                                                'ë' = 'ee',
                                                                'ö' = 'oe',
                                                                'ü' = 'ue',
                                                                'Ä' = 'Ae',
                                                                'Ë' = 'Ee',
                                                                'Ö' = 'Oe',
                                                                'Ü' = 'Ue',
                                                                'ß' = 'ss',
                                                                'é' = 'e',
                                                                'è' = 'e',
                                                                'ê' = 'e',
                                                                'ç' = 'c',
                                                                'á' = 'a',
                                                                'à' = 'a',
                                                                'â' = 'a',
                                                                'í' = 'i',
                                                                'ì' = 'i',
                                                                'î' = 'i',
                                                                'ó' = 'o',
                                                                'ò' = 'o',
                                                                'ô' = 'o',
                                                                'ú' = 'u',
                                                                'ù' = 'u',
                                                                'û' = 'u',
                                                                'ñ' = 'n',
                                                                'ý' = 'y',
                                                                'ÿ' = 'y',
                                                                'å' = 'a',
                                                                'ø' = 'o',
                                                                'Æ' = 'Ae',
                                                                'Ø' = 'Oe',
                                                                'Å' = 'Aa',
                                                                'ą' = 'a',
                                                                'ć' = 'c',
                                                                'ę' = 'e',
                                                                'ł' = 'l',
                                                                'ń' = 'n',
                                                                'ś' = 's',
                                                                'ź' = 'z',
                                                                'ż' = 'z',
                                                                'Ą' = 'A',
                                                                'Ć' = 'C',
                                                                'Ę' = 'E',
                                                                'Ł' = 'L',
                                                                'Ń' = 'N',
                                                                'Ś' = 'S',
                                                                'Ź' = 'Z',
                                                                'Ż' = 'Z',
                                                                'č' = 'c',
                                                                'ď' = 'd',
                                                                'ě' = 'e',
                                                                'ň' = 'n',
                                                                'ř' = 'r',
                                                                'š' = 's',
                                                                'ť' = 't',
                                                                'ů' = 'u',
                                                                'ž' = 'z',
                                                                'Č' = 'C',
                                                                'Ď' = 'D',
                                                                'Ě' = 'E',
                                                                'Ň' = 'N',
                                                                'Ř' = 'R',
                                                                'Š' = 'S',
                                                                'Ť' = 'T',
                                                                'Ů' = 'U',
                                                                'Ž' = 'Z',
                                                                '⁸' = '',
                                                                '♀' = '',
                                                                '‘' = '',
                                                                'ã' = 'a',
                                                                'ğ' = 'g',
                                                                'É' = 'E',
                                                                'Á' = 'A',
                                                                'ş' = 's',
                                                                'ū' = 'u',
                                                                'ė' = 'e',
                                                                'æ' = 'ae',
                                                                'É' = 'E',
                                                                'ş' = 's',
                                                                'ı' = 'l',
                                                                'ö' = 'oe',
                                                                '!' = ''
                                                              ))))

# Die nicht geladenen Spalten neu einbinden und mit festen Werten speichern #
# Enstprechend der alten Vorgaben im SAS-Script von Mareike #

cleaned_df$validfrom <- ""
cleaned_df$validuntil <- ""
cleaned_df$invited <- "N"
cleaned_df$reminded <- "N"
cleaned_df$remindercount <- "0"
cleaned_df$completed <- "N"
cleaned_df$usesleft <- "1"

# sort at the beginning of the dataframe ####
list_for_email_sort <- c("Niki2007dc@gmx.com","Nadine.Glaser97@web.de","Jasmin.kroeber@gmx.de")
for (element in list_for_email_sort){
  specific_rows <- cleaned_df[cleaned_df$email == element, ]
  cleaned_df <- cleaned_df[cleaned_df$email != element, ]
  cleaned_df <- rbind(specific_rows, cleaned_df)
}



setwd("P:/IMEBI/DigiHero_Teilnehmerdaten/Massenmails/tokenaufbereiter/erstellte_Dateien")
# after cleaning . start with the user query ####
function_start()
